"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_1 = require("react");
var prop_types_1 = require("prop-types");
var react_syntax_highlighter_1 = require("react-syntax-highlighter");
var supportedLanguages_1 = require("./supportedLanguages");
var themeBuilder_1 = require("./themes/themeBuilder");
var allowedLanguagesList = supportedLanguages_1.languageList.concat('text');
var Code = (function (_super) {
    tslib_1.__extends(Code, _super);
    function Code() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Code.prototype.render = function () {
        var language = this.props.language;
        var inlineCodeStyle = themeBuilder_1.applyTheme(this.props.theme).inlineCodeStyle;
        // @see https://github.com/conorhastings/react-syntax-highlighter/issues/87
        if (language === 'text') {
            return (React.createElement("span", { style: inlineCodeStyle.hljs },
                React.createElement("code", null, this.props.text)));
        }
        var props = {
            language: supportedLanguages_1.normalizeLanguage(language),
            PreTag: 'span',
            style: inlineCodeStyle,
            showLineNumbers: false
        };
        return (React.createElement(react_syntax_highlighter_1.default, tslib_1.__assign({}, props), this.props.text));
    };
    return Code;
}(react_1.PureComponent));
Code.propTypes = {
    /** The code to be formatted */
    text: prop_types_1.PropTypes.string.isRequired,
    /** The language in which the code is written */
    language: prop_types_1.PropTypes.oneOf(allowedLanguagesList),
    /** A custom theme to be applied, implements the Theme interface */
    theme: prop_types_1.PropTypes.object
};
Code.defaultProps = {
    theme: {},
};
exports.default = Code;
//# sourceMappingURL=Code.js.map